diff -Nru t1lib-grace/T1lib/t1lib/t1trans.c t1lib-deb/T1lib/t1lib/t1trans.c
--- t1lib-grace/T1lib/t1lib/t1trans.c	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1trans.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1trans.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-04-01
+  ----- Date:        2005-05-01
   ----- Description: This file is part of the t1-library. It contains
                      functions for transforming fonts and setting
 		     line-parameters.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -51,6 +51,7 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 
@@ -69,7 +70,7 @@
 {
   
   /* First, check for font residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -95,7 +96,7 @@
 double T1_GetExtend( int FontID)
 {
   /* First, check for font residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -115,7 +116,7 @@
 {
   
   /* First, check for font residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -141,7 +142,7 @@
 double T1_GetSlant( int FontID)
 {
   /* First, check for font residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -160,7 +161,7 @@
 {
   
   /* First, check for font residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -190,7 +191,7 @@
   T1_TMATRIX tmatrix={0.0, 0.0, 0.0, 0.0};
   
   /* First, check for font residing in memory: */
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(tmatrix);
   }
@@ -212,7 +213,7 @@
 int T1_SetLinePosition( int FontID, int linetype, float value)
 {
 
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -241,7 +242,7 @@
 int T1_SetLineThickness( int FontID, int linetype, float value)
 {
 
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(-1);
   }
@@ -269,7 +270,7 @@
 float T1_GetLinePosition( int FontID, int linetype)
 {
 
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -292,7 +293,7 @@
 float T1_GetLineThickness( int FontID, int linetype)
 {
 
-  if (CheckForFontID(FontID)!=1){
+  if (T1_CheckForFontID(FontID)!=1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(0.0);
   }
@@ -534,3 +535,169 @@
 }
 
 
+
+/* T1_StrokeFont(): Switch the  font referenced by FontID to stroking
+   or filling. The stroked character will be cached and 
+   filled characters are no longer cached and vice versa.
+   This is only allowed if no size dependent data exists.
+   Of course, the font must already have been loaded.
+   Returns 0 for success and -1 otherwise.
+   */
+int T1_StrokeFont( int FontID, int dostroke)
+{
+  
+  /* First, check for font residing in memory: */
+  if ( T1_CheckForFontID( FontID) != 1 ) {
+    T1_errno = T1ERR_INVALID_FONTID;
+    return -1;
+  }
+  
+  /* Second, check whether size-dependent data exists: */
+  if ( pFontBase->pFontArray[FontID].pFontSizeDeps != NULL ) {
+    T1_errno = T1ERR_OP_NOT_PERMITTED;
+    return -1; 
+  }
+
+  if ( dostroke != 0 ) {
+    pFontBase->pFontArray[FontID].info_flags |= RASTER_STROKED;
+    pFontBase->pFontArray[FontID].info_flags |= CACHE_STROKED;
+  }
+  else {
+    pFontBase->pFontArray[FontID].info_flags &= ~RASTER_STROKED;
+    pFontBase->pFontArray[FontID].info_flags &= ~CACHE_STROKED;
+  }
+  
+
+  return 0;
+}
+
+
+
+/* T1_SetStrokeFlag(): Return the stroke flag for font FontID.
+   Return:  0                      flag has been set
+           -1                      flag could not be set 
+*/
+int T1_SetStrokeFlag( int FontID)
+{
+  /* First, check for font residing in memory: */
+  if ( T1_CheckForFontID(FontID) != 1 ) {
+    T1_errno = T1ERR_INVALID_FONTID;
+    return -1;
+  }
+  
+  /* Set stroke flag to true */
+  pFontBase->pFontArray[FontID].info_flags |= RASTER_STROKED;
+  
+  return 0;
+  
+}
+
+
+
+/* T1_ClearStrokeFlag(): Reset the stroke flag for font FontID.
+   Return:  0                      flag has been reset
+           -1                      flag could not be reset 
+*/
+int T1_ClearStrokeFlag( int FontID)
+{
+  /* First, check for font residing in memory: */
+  if ( T1_CheckForFontID(FontID) != 1 ) {
+    T1_errno = T1ERR_INVALID_FONTID;
+    return -1;
+  }
+
+  /* Reset stroke flag */
+  pFontBase->pFontArray[FontID].info_flags &= ~RASTER_STROKED;
+  
+  return 0;
+  
+}
+
+
+
+/* T1_GetStrokeMode(): Return the stroke flag for font FontID.
+   Return: -1                      if font is not loaded.
+	    0                      if flag is reset,
+	    1                      if stroking is enabled for this font,
+	    2                      if stroked characters are cached,
+	    3                      if stroking is enabled and stroked
+	                           characters are cached.
+*/
+int T1_GetStrokeMode( int FontID)
+{
+  int outval = 0;
+  
+  /* First, check for font residing in memory: */
+  if ( T1_CheckForFontID( FontID) != 1 ) {
+    T1_errno = T1ERR_INVALID_FONTID;
+    return -1;
+  }
+
+  if ( (pFontBase->pFontArray[FontID].info_flags & CACHE_STROKED) != 0 ) 
+    outval |= 0x02;
+  
+  if ( (pFontBase->pFontArray[FontID].info_flags & RASTER_STROKED) != 0 ) 
+    outval |= 0x01;
+  
+  return outval;
+    
+}
+
+
+
+/* T1_SetStrokeWidth(): Set the penwidth used when stroking font FontID.
+   Return  -1           If width could not be set.
+            0           if width has been set.
+ */
+int T1_SetStrokeWidth( int FontID, float strokewidth)
+{
+  /* First, check for font residing in memory: */
+  if ( T1_CheckForFontID( FontID) != 1 ) {
+    T1_errno = T1ERR_INVALID_FONTID;
+    return -1;
+  }
+
+  /* Second, check whether caching stroked characters is enabled
+     for this font and glyph data is already existing. In this case
+     the operation is forbidden, unless the previous non-zero value
+     is just restored! */
+  if ( ((pFontBase->pFontArray[FontID].info_flags & CACHE_STROKED) != 0) &&
+       (pFontBase->pFontArray[FontID].pFontSizeDeps != NULL) &&
+       (pFontBase->pFontArray[FontID].SavedStrokeWidth != strokewidth)
+       ) {
+    T1_errno = T1ERR_OP_NOT_PERMITTED;
+    return -1; 
+  }
+
+  /* OK, accept stroke width after ensuring a numerically meaningful
+     value */
+  if ( strokewidth < 0.0f ) {
+    T1_errno = T1ERR_INVALID_PARAMETER;
+    return -1;
+  }
+
+  pFontBase->pFontArray[FontID].StrokeWidth = strokewidth;
+  
+  if ( strokewidth != 0.0f )
+    pFontBase->pFontArray[FontID].SavedStrokeWidth = strokewidth;
+  
+  return 0;
+    
+}
+
+
+
+/* T1_GetStrokeWidth(): Get the penwidth used when stroking font FontID.
+   If 0.0 is returned, it might also indicate that the font is not loaded.
+*/
+float T1_GetStrokeWidth( int FontID)
+{
+  /* First, check for font residing in memory: */
+  if ( T1_CheckForFontID( FontID) != 1 ) {
+    T1_errno = T1ERR_INVALID_FONTID;
+    return 0.0f;
+  }
+
+  return pFontBase->pFontArray[FontID].StrokeWidth;  
+}
+
diff -Nru t1lib-grace/T1lib/t1lib/t1trans.h t1lib-deb/T1lib/t1lib/t1trans.h
--- t1lib-grace/T1lib/t1lib/t1trans.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1trans.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1trans.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-04-01
+  ----- Date:        2002-10-19
   ----- Description: This file is part of the t1-library. It contains
                      definitions and declarations fort t1trans.c
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2002. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -47,9 +47,17 @@
 T1_TMATRIX *T1_TransformMatrix( T1_TMATRIX *matrix,
 				double cxx, double cyx,
 				double cxy, double cyy);
+int T1_StrokeFont( int FontID, int dostroke);
+int T1_SetStrokeFlag( int FontID);
+int T1_ClearStrokeFlag( int FontID);
+int T1_GetStrokeMode( int FontID);
+int T1_SetStrokeWidth( int FontID, float strokewidth);
+float T1_GetStrokeWidth( int FontID);
+
 
 #else
 
+
 extern int T1_ExtendFont( int FontID, double extend);
 extern int T1_SlantFont( int FontID, double slant);
 extern int T1_TransformFont( int FontID, T1_TMATRIX *matrix);
@@ -70,6 +78,12 @@
 extern T1_TMATRIX *T1_TransformMatrix( T1_TMATRIX *matrix,
 				       double cxx, double cyx,
 				       double cxy, double cyy);
+extern int T1_StrokeFont( int FontID, int dostroke);
+extern int T1_SetStrokeFlag( int FontID);
+extern int T1_ClearStrokeFlag( int FontID);
+extern int T1_GetStrokeMode( int FontID);
+extern int T1_SetStrokeWidth( int FontID, float strokewidth);
+extern float T1_GetStrokeWidth( int FontID);
 
 #endif
 
diff -Nru t1lib-grace/T1lib/t1lib/t1types.h t1lib-deb/T1lib/t1lib/t1types.h
--- t1lib-grace/T1lib/t1lib/t1types.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1types.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1types.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-06-04
+  ----- Date:        2004-12-09
   ----- Description: This file is part of the t1-library. It contains
                      type definitions used by the t1-library.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2004. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -28,6 +28,7 @@
 
 #define T1TYPES_H
 
+#include "sysconf.h"
 
 typedef struct
 {
@@ -74,6 +75,9 @@
   float OvrLnThick;
   float OvrStrkPos;
   float OvrStrkThick;
+  float StrokeWidth;
+  float SavedStrokeWidth;
+  
   unsigned short physical; /* This entry is used to decide, whether a
 			      font is associated with an own physical
 			      fontfile, or whether it has been created
@@ -144,7 +148,7 @@
 
 
 
-/* A data that makes most important information available to user. */
+/* A data type that makes most important information available to user. */
 typedef struct
 {
   int      width;       /* The glyph's width */
@@ -161,14 +165,14 @@
  
 #define   FRACTBITS     16   /* number of fractional bits in 'fractpel'      */
 /* From/to conversion of pels/fractpels */
-#define   T1_TOPATHPOINT(p)      (((long)p)<<FRACTBITS)
+#define   T1_TOPATHPOINT(p)      (((T1_AA_TYPE32)p)<<FRACTBITS)
 #define   PPHALF                 (1<<(FRACTBITS-1))
 #define   T1_NEARESTPOINT(fp)    (((fp)+PPHALF)>>FRACTBITS)
 
 /* A fractional point */
 typedef struct {
-  long x;
-  long y;
+  T1_AA_TYPE32 x;
+  T1_AA_TYPE32 y;
 } T1_PATHPOINT;
 
 
